#ifndef _LANG_H
#define _LANG_H

// for text mode
#define	IN_FILE_ERR "  infile <%s> not found!\n"
#define	OUT_FILE_ERR "  cannot open outfile <%s>!\n"
#define	UTF16_NO_DETECT_ERR "  can't detect utf-16 be/le version\n"
#define	END_LINE_ERR "  define out_end_line_type but not define in_end_line_type\n"
#define	FILE_ERR "  ERROR: infile = outfile\n"

#define	HELP "
Convert Unicode (UTF) text file

usage: utf_convert in_type in_end_line_type out_type out_end_line_type [infile] [outfile]
 if infile / outfile is not declared program used standard input / output

Convert Unicode from (in_type - description):
 utf7     -   UTF-7
 utf8     -   UTF-8
 utf16    -   UTF-16 (UCS-2) autodetect Big Endian (high endian) or Little Endian (low endian)
 utf16be  -   UTF-16 (UCS-2) - Big Endian (high endian)
 utf16le  -   UTF-16 (UCS-2) - Little Endian (low endian)

Convert Unicode to (out_type - description):
 utf7     -   UTF-7
 utf8     -   UTF-8
 utf16be  -   UTF-16 (UCS-2) - Big Endian (high endian)
 utf16le  -   UTF-16 (UCS-2) - Little Endian (low endian)

Convert end line style (in_end_line_type=out_end_line_type - description):
 lf       -   UNIX
 crlf     -   DOS / WINDOWS
 cr       -   MAC
 -        -   not convert end line

* UTF-7 with optional characters encoded directly actually is not suppored :-(
* UCS-2 for Java actually is not suppored :-(
* UTF-32 (UCS-4) actually is not suppored :-(
"

// for GUI
#define	ALERT_IN_FILE_ERR "Infile not found!\n\nConversion is not possible."
#define	ALERT_OUT_FILE_ERR "Cannot open outfile!\n\nConversion is not possible."
#define	ALERT_UTF16_NO_DETECT_ERR "Can't detect utf-16 be/le version\n\nConversion is not possible."
#define	ALERT_END_LINE_ERR "Definied output endline style, but not definied input.\n\nEnd line style convert ignored !!!"
#define	ALERT_FILE_ERR "ERROR: inputfile = outputfile\n\nConversion is not possible."
#define	ALERT_CONV_SUCSES "Convert sucsesfull !!!"

#define	IN_TYPE "Input encoding:"
#define	IN_END_LINE "Input end-line type:"
#define	OUT_TYPE "Output encoding:"
#define	OUT_END_LINE "Output end-line type:"
#define	IN_PATH "Input file path:"
#define	OUT_PATH "Output file path:"
#define	CONVERT "Convert"
#define	WINDOW_TITLE "UTF convert"


#endif