/****       *  UTF-16be  *       ****/

#include "convert.h"

static	bool	utf16_bom_put;

// get unicode from UTF-16be
Char utf16be_getc(FILE *f)
{
	register	unsigned short	unichar_1;
	register	unsigned short	unichar_2;
	
	unichar_1 = getc(f);
	unichar_2 = getc(f);
	
	// EOF - end file
	if (unichar_1 == (unsigned short)EOF || unichar_2 == (unsigned short)EOF)
		return EOF;
	
	// BOM code
	if (unichar_1 == 0xfe || unichar_2 == 0xff)
		return NULL;
	
	// return unicode
	return (unichar_1 << 8) | unichar_2;
}

// put unicode to UTF-16be
int utf16be_putc(Char wc, FILE *f)
{
	// write BOM code
	if ( !utf16_bom_put ) {
		Char	unichar;
		unichar = 0xfeff;
		fwrite(&unichar, sizeof(unsigned short), 1, f);
		utf16_bom_put = true;
	}

	if (wc != 0xfffe) {
		wc = (wc >> 8) | ((wc%256) << 8); // uni -> be
		fwrite(&wc, sizeof(unsigned short), 1, f);
	}
	
	return 0;	
}





/****       *  UTF-16le  *       ****/

// get unicode from UTF-16le
Char utf16le_getc(FILE *f)
{
	register	unsigned short	unichar_1;
	register	unsigned short	unichar_2;
	
	unichar_1 = getc(f);
	unichar_2 = getc(f);
	
	// EOF - end file
	if (unichar_1 == (unsigned short)EOF || unichar_2 == (unsigned short)EOF)
		return EOF;
	
	// BOM code
	if (unichar_1 == 0xff || unichar_2 == 0xfe)
		return NULL;
	
	// return unicode
	return (unichar_2 << 8) | unichar_1;
}

// put unicode to UTF-16le
int utf16le_putc(Char wc, FILE *f)
{
	// write BOM code
	if ( !utf16_bom_put ) {
		Char	unichar;
		unichar = 0xfffe;
		fwrite(&unichar, sizeof(unsigned short), 1, f);
		utf16_bom_put = true;
	}

	if (wc != 0xfffe) {
		fwrite(&wc, sizeof(unsigned short), 1, f);
	}
	
	return 0;
}